From 41152499cddf14cb5f4d7e6fc85b343352dd1ca8 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Wed, 20 Oct 2021 16:04:23 +0200
Subject: [PATCH 2/2] openssl3: base work

---
 Makefile.inc1                              |    6 +-
 Makefile_upgrade.inc                       |   37 +-
 bin/cpdup/Makefile                         |    1 +
 bin/ed/Makefile                            |    3 +-
 contrib/cryptsetup/lib/backends.c          |   10 +-
 contrib/cryptsetup/luks/af.c               |   12 +-
 contrib/cryptsetup/luks/pbkdf.c            |   12 +-
 etc/mtree/BSD.usr.dist                     |    4 +
 games/factor/Makefile                      |    2 +-
 gnu/lib/libcryptsetup/Makefile             |    2 +-
 gnu/lib/libluks/Makefile                   |    3 +-
 gnu/sbin/cryptsetup/Makefile               |    8 +-
 initrd/mkinitrd.sh                         |    2 +-
 lib/Makefile                               |    4 +-
 lib/libarchive/Makefile                    |    3 +-
 lib/libcrypt/Makefile                      |    2 +-
 lib/libcrypto/Makefile                     | 1253 ++++++++++++++++++
 lib/libcrypto/Makefile.inc                 |   52 +
 lib/libcrypto/engines/Makefile             |    8 +
 lib/libcrypto/engines/Makefile.inc         |   14 +
 lib/libcrypto/engines/capi/Makefile        |    7 +
 lib/libcrypto/engines/padlock/Makefile     |   10 +
 lib/libdmsg/Makefile                       |    3 +-
 lib/libdmsg/crypto.c                       |   38 +-
 lib/libdmsg/dmsg.h                         |    2 +-
 lib/libfetch/Makefile                      |    2 +-
 lib/libldns/Makefile                       |    3 +-
 lib/libldns/ldns/config.h                  |   14 +-
 lib/librecrypto/Makefile                   |  303 -----
 lib/librecrypto/Makefile.inc               |   12 -
 lib/librecrypto/dfly_config.txt            |  110 --
 lib/libressl/Makefile                      |   41 -
 lib/libssh/Makefile                        |    3 +-
 lib/libssh/config.h                        |   18 +-
 lib/libssh/openbsd-compat/openssl-compat.c |   58 +
 lib/libssh/openbsd-compat/openssl-compat.h |   10 +
 lib/libssl/Makefile                        |   45 +
 lib/libtcplay/Makefile                     |    2 +-
 lib/libtelnet/Makefile                     |    3 +-
 lib/libtelnet/pk.c                         |    1 -
 libexec/dma/dma-mbox-create/Makefile       |    2 +-
 libexec/dma/dma/Makefile                   |    3 +-
 libexec/ftpd/Makefile                      |    1 +
 libexec/sftp-server/Makefile               |    2 +-
 libexec/ssh-keysign/Makefile               |    2 +-
 libexec/ssh-pkcs11-helper/Makefile         |    2 +-
 libexec/telnetd/Makefile                   |    2 +-
 sbin/cryptdisks/Makefile                   |    6 +-
 sbin/dhcpcd/Makefile                       |    1 +
 sbin/fsck_hammer2/Makefile                 |    2 +
 sbin/hammer/Makefile                       |    1 +
 sbin/hammer2/Makefile                      |    1 +
 sbin/iscontrol/Makefile                    |    1 +
 sbin/md5/Makefile                          |    1 +
 sbin/mount_hammer2/Makefile                |    2 +-
 sbin/ping6/Makefile                        |    1 +
 sbin/routed/Makefile                       |    1 +
 sbin/routed/rtquery/Makefile               |    1 +
 sbin/tcplay/Makefile                       |    2 +-
 share/examples/etc/README.examples         |    1 -
 share/examples/ssl/Makefile                |    2 +-
 tools/tools/net80211/w00t/Makefile.inc     |    2 +-
 usr.bin/bdes/Makefile                      |    3 +-
 usr.bin/chkey/Makefile                     |    2 +-
 usr.bin/dc/Makefile                        |    3 +-
 usr.bin/dc/bcode.c                         |    6 +-
 usr.bin/dc/bcode.h                         |    1 +
 usr.bin/dc/inout.c                         |   22 +-
 usr.bin/drill/Makefile                     |    2 +-
 usr.bin/dsynth/Makefile                    |    1 +
 usr.bin/nc/Makefile                        |   24 +-
 usr.bin/nc/atomicio.c                      |   67 +
 usr.bin/nc/atomicio.h                      |   39 +
 usr.bin/nc/nc.1                            |  532 ++++++++
 usr.bin/nc/netcat.c                        | 1370 ++++++++++++++++++++
 usr.bin/nc/socks.c                         |  340 +++++
 usr.bin/newkey/Makefile                    |    2 +-
 usr.bin/newkey/generic.c                   |    1 -
 usr.bin/openssl/Makefile                   |   28 +-
 usr.bin/openssl/Makefile.etc               |    9 +-
 usr.bin/openssl/Makefile.inc               |    3 +
 usr.bin/openssl/libapps/Makefile           |   14 +
 usr.bin/openssl/openssl/Makefile           |   27 +
 usr.bin/scp/Makefile                       |    2 +-
 usr.bin/sort/Makefile                      |    1 +
 usr.bin/ssh-add/Makefile                   |    2 +-
 usr.bin/ssh-agent/Makefile                 |    2 +-
 usr.bin/ssh-keygen/Makefile                |    3 +-
 usr.bin/ssh-keyscan/Makefile               |    2 +-
 usr.bin/ssh/Makefile                       |    2 +-
 usr.bin/telnet/Makefile                    |    2 +-
 usr.sbin/802_11/Makefile.crypto            |    3 +-
 usr.sbin/ckdist/Makefile                   |    2 +-
 usr.sbin/keyserv/Makefile                  |    2 +-
 usr.sbin/mtree/Makefile                    |    1 +
 usr.sbin/pfctl/Makefile                    |    1 +
 usr.sbin/ppp/Makefile                      |    1 +
 usr.sbin/sshd/Makefile                     |    3 +-
 usr.sbin/tcpdump/Makefile                  |    3 +-
 usr.sbin/uefisign/Makefile                 |    2 +-
 100 files changed, 4055 insertions(+), 637 deletions(-)
 create mode 100644 lib/libcrypto/Makefile
 create mode 100644 lib/libcrypto/Makefile.inc
 create mode 100644 lib/libcrypto/engines/Makefile
 create mode 100644 lib/libcrypto/engines/Makefile.inc
 create mode 100644 lib/libcrypto/engines/capi/Makefile
 create mode 100644 lib/libcrypto/engines/padlock/Makefile
 delete mode 100644 lib/librecrypto/Makefile
 delete mode 100644 lib/librecrypto/Makefile.inc
 delete mode 100644 lib/librecrypto/dfly_config.txt
 delete mode 100644 lib/libressl/Makefile
 create mode 100644 lib/libssl/Makefile
 create mode 100644 usr.bin/nc/atomicio.c
 create mode 100644 usr.bin/nc/atomicio.h
 create mode 100644 usr.bin/nc/nc.1
 create mode 100644 usr.bin/nc/netcat.c
 create mode 100644 usr.bin/nc/socks.c
 create mode 100644 usr.bin/openssl/Makefile.inc
 create mode 100644 usr.bin/openssl/libapps/Makefile
 create mode 100644 usr.bin/openssl/openssl/Makefile

diff --git a/Makefile.inc1 b/Makefile.inc1
index 79cfa9bc62..aecb46dcf0 100644
--- a/Makefile.inc1
+++ b/Makefile.inc1
@@ -1051,11 +1051,11 @@ _prebuild_libs+= lib/libcrypt lib/libncurses/libncurses
 
 _generic_libs+=	lib
 
-_prebuild_libs+=	lib/librecrypto lib/libressl
-lib/libressl__L: lib/librecrypto__L
+_prebuild_libs+=	lib/libcrypto lib/libssl
+lib/libssl__L: lib/libcrypto__L
 
 _prebuild_libs+=       lib/libldns
-lib/libldns__L: lib/librecrypto__L
+lib/libldns__L: lib/libcrypto__L
 
 _prebuild_libs+= lib/libsbuf lib/libm \
 		lib/libpam/libpam lib/libypclnt lib/lib${THREAD_LIB} \
diff --git a/Makefile_upgrade.inc b/Makefile_upgrade.inc
index cc2203e905..1a2fa8673e 100644
--- a/Makefile_upgrade.inc
+++ b/Makefile_upgrade.inc
@@ -3919,6 +3919,40 @@ TO_REMOVE+=/usr/include/sys/vmm.h
 TO_REMOVE+=/usr/share/man/man2/vmm.2.gz
 TO_REMOVE+=/usr/share/man/man2/vmm_guest_ctl.2.gz
 TO_REMOVE+=/usr/share/man/man2/vmm_guest_sync_addr.2.gz
+TO_REMOVE+=/usr/include/priv/openssl/aes.h
+TO_REMOVE+=/usr/include/priv/openssl/asn1t.h
+TO_REMOVE+=/usr/include/priv/openssl/blowfish.h
+TO_REMOVE+=/usr/include/priv/openssl/camellia.h
+TO_REMOVE+=/usr/include/priv/openssl/cast.h
+TO_REMOVE+=/usr/include/priv/openssl/chacha.h
+TO_REMOVE+=/usr/include/priv/openssl/cmac.h
+TO_REMOVE+=/usr/include/priv/openssl/cms.h
+TO_REMOVE+=/usr/include/priv/openssl/conf_api.h
+TO_REMOVE+=/usr/include/priv/openssl/curve25519.h
+TO_REMOVE+=/usr/include/priv/openssl/dso.h
+TO_REMOVE+=/usr/include/priv/openssl/ecdh.h
+TO_REMOVE+=/usr/include/priv/openssl/ecdsa.h
+TO_REMOVE+=/usr/include/priv/openssl/gost.h
+TO_REMOVE+=/usr/include/priv/openssl/hkdf.h
+TO_REMOVE+=/usr/include/priv/openssl/idea.h
+TO_REMOVE+=/usr/include/priv/openssl/modes.h
+TO_REMOVE+=/usr/include/priv/openssl/opensslfeatures.h
+TO_REMOVE+=/usr/include/priv/openssl/pem2.h
+TO_REMOVE+=/usr/include/priv/openssl/pkcs12.h
+TO_REMOVE+=/usr/include/priv/openssl/poly1305.h
+TO_REMOVE+=/usr/include/priv/openssl/rand.h
+TO_REMOVE+=/usr/include/priv/openssl/rc2.h
+TO_REMOVE+=/usr/include/priv/openssl/sm3.h
+TO_REMOVE+=/usr/include/priv/openssl/sm4.h
+TO_REMOVE+=/usr/include/priv/openssl/ssl23.h
+TO_REMOVE+=/usr/include/priv/openssl/ts.h
+TO_REMOVE+=/usr/include/priv/openssl/txt_db.h
+TO_REMOVE+=/usr/include/priv/openssl/ui.h
+TO_REMOVE+=/usr/include/priv/openssl/whrlpool.h
+TO_REMOVE+=/usr/include/priv/openssl/x509_verify.h
+# XXX
+TO_REMOVE+=/usr/share/man/man1/openssl.1.gz
+TO_REMOVE+=/usr/share/man/man5/openssl.cnf.5.gz
 
 .if !defined(WANT_INSTALLER)
 TO_REMOVE+=/usr/sbin/dfuibe_installer
@@ -3941,7 +3975,6 @@ TO_REMOVE_LATE+=/lib/libcrypto.so.5
 TO_REMOVE_LATE+=/usr/lib/libssl.a
 TO_REMOVE_LATE+=/usr/lib/libssl.so
 TO_REMOVE_LATE+=/usr/lib/libssl.so.5
-TO_REMOVE_LATE+=/usr/lib/engines
 TO_REMOVE_LATE+=/usr/lib/libcrypto.so
 TO_REMOVE_LATE+=/usr/lib/libcrypto.a
 TO_REMOVE_LATE+=/usr/lib/profile/libssl.a
@@ -3954,6 +3987,8 @@ TO_REMOVE_LATE+=/lib/priv/libprivate_crypto.so.38
 TO_REMOVE_LATE+=/lib/priv/libprivate_ssl.so.39
 TO_REMOVE_LATE+=/lib/libprivate_crypto.so.45
 TO_REMOVE_LATE+=/lib/libprivate_ssl.so.47
+TO_REMOVE_LATE+=/lib/libprivate_crypto.so.46
+TO_REMOVE_LATE+=/lib/libprivate_ssl.so.48
 
 # XXX Remove when pfsync(4) has been fixed
 TO_REMOVE+=/usr/share/man/man4/pfsync.4.gz
diff --git a/bin/cpdup/Makefile b/bin/cpdup/Makefile
index c95639efdb..8f09b260fa 100644
--- a/bin/cpdup/Makefile
+++ b/bin/cpdup/Makefile
@@ -7,6 +7,7 @@ CFLAGS+=	-DNOMD5
 .else
 .if !defined(NOMD5)
 SRCS+=		md5.c
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 CFLAGS+=	${PRIVATELIB_CFLAGS}
 DPADD=		${LIBCRYPTO}
 LDADD=		-lprivate_crypto
diff --git a/bin/ed/Makefile b/bin/ed/Makefile
index e2f157e480..20e6579f8e 100644
--- a/bin/ed/Makefile
+++ b/bin/ed/Makefile
@@ -6,7 +6,8 @@ SRCS=	buf.c cbc.c glbl.c io.c main.c re.c sub.c undo.c
 LINKS=	${BINDIR}/ed ${BINDIR}/red
 MLINKS=	ed.1 red.1
 
-CFLAGS+=	-DDES -I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-DDES -DOPENSSL_SUPPRESS_DEPRECATED
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 DPADD=		${LIBCRYPTO}
 LDADD=		-lprivate_crypto
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
diff --git a/contrib/cryptsetup/lib/backends.c b/contrib/cryptsetup/lib/backends.c
index 488ccef09c..2359349fcf 100644
--- a/contrib/cryptsetup/lib/backends.c
+++ b/contrib/cryptsetup/lib/backends.c
@@ -16,7 +16,7 @@ int hash(const char *backend_name, const char *hash_name,
          char *result, size_t size,
          const char *passphrase, size_t sizep)
 {
-	EVP_MD_CTX mdctx;
+	EVP_MD_CTX *mdctx;
 	const EVP_MD *md;
 	size_t pad = 0;
 	int r = -ENOENT;
@@ -35,9 +35,11 @@ int hash(const char *backend_name, const char *hash_name,
 
 	pad = size - EVP_MD_size(md);
 
-	EVP_DigestInit(&mdctx, md);
-	EVP_DigestUpdate(&mdctx, passphrase, sizep);
-	r = !EVP_DigestFinal(&mdctx, result, NULL);
+	mdctx = EVP_MD_CTX_new();
+	EVP_DigestInit(mdctx, md);
+	EVP_DigestUpdate(mdctx, passphrase, sizep);
+	r = !EVP_DigestFinal(mdctx, result, NULL);
+	EVP_MD_CTX_free(mdctx);
 
 	if (pad) {
 		memset(result+size, 0, pad);
diff --git a/contrib/cryptsetup/luks/af.c b/contrib/cryptsetup/luks/af.c
index 2d3acc0b60..ec1c999072 100644
--- a/contrib/cryptsetup/luks/af.c
+++ b/contrib/cryptsetup/luks/af.c
@@ -38,15 +38,17 @@ static void XORblock(char const *src1, char const *src2, char *dst, size_t n)
 
 static int hash_buf(char *src, char *dst, uint32_t iv, int len, const EVP_MD *hash_id)
 {
-	EVP_MD_CTX mdctx;
+	EVP_MD_CTX *mdctx;
 	unsigned char digest[128];
 
 	iv = htonl(iv);
 
-	EVP_DigestInit(&mdctx, hash_id);
-	EVP_DigestUpdate(&mdctx, (unsigned char *)&iv, sizeof(iv));
-	EVP_DigestUpdate(&mdctx, src, len);
-	EVP_DigestFinal(&mdctx, digest, NULL);
+	mdctx = EVP_MD_CTX_new();
+	EVP_DigestInit(mdctx, hash_id);
+	EVP_DigestUpdate(mdctx, (unsigned char *)&iv, sizeof(iv));
+	EVP_DigestUpdate(mdctx, src, len);
+	EVP_DigestFinal(mdctx, digest, NULL);
+	EVP_MD_CTX_free(mdctx);
 	memcpy(dst, digest, len);
 
 	return 0;
diff --git a/contrib/cryptsetup/luks/pbkdf.c b/contrib/cryptsetup/luks/pbkdf.c
index 31e5da4d51..6b52de848e 100644
--- a/contrib/cryptsetup/luks/pbkdf.c
+++ b/contrib/cryptsetup/luks/pbkdf.c
@@ -72,7 +72,7 @@ static int pkcs5_pbkdf2(const char *hash,
 	char U[MAX_PRF_BLOCK_LEN];
 	char T[MAX_PRF_BLOCK_LEN];
 	const EVP_MD *PRF;
-	HMAC_CTX ctx;
+	HMAC_CTX *ctx;
 	int i, k, rc = -EINVAL;
 	unsigned int u, hLen, l, r;
 	unsigned char *p;
@@ -169,7 +169,7 @@ static int pkcs5_pbkdf2(const char *hash,
 	 *  into a small set of values.
 	 *
 	 */
-	HMAC_CTX_init(&ctx);
+	ctx = HMAC_CTX_new();
 
 	for (i = 1; (uint) i <= l; i++) {
 		memset(T, 0, hLen);
@@ -181,9 +181,9 @@ static int pkcs5_pbkdf2(const char *hash,
 				tmp[Slen + 1] = (i & 0x00ff0000) >> 16;
 				tmp[Slen + 2] = (i & 0x0000ff00) >> 8;
 				tmp[Slen + 3] = (i & 0x000000ff) >> 0;
-				HMAC_Init_ex(&ctx, P, Plen, PRF, NULL);
-				HMAC_Update(&ctx, tmp, tmplen);				
-				HMAC_Final(&ctx, U, NULL);
+				HMAC_Init_ex(ctx, P, Plen, PRF, NULL);
+				HMAC_Update(ctx, tmp, tmplen);				
+				HMAC_Final(ctx, U, NULL);
 			} else {
 				HMAC(PRF, P, Plen, U, hLen, U, NULL);
 			}
@@ -204,7 +204,7 @@ static int pkcs5_pbkdf2(const char *hash,
 	}
 	rc = 0;
 out:
-	HMAC_CTX_cleanup(&ctx);
+	HMAC_CTX_free(ctx);
 	return rc;
 }
 
diff --git a/etc/mtree/BSD.usr.dist b/etc/mtree/BSD.usr.dist
index 74f5d30b9a..f41f77bf41 100644
--- a/etc/mtree/BSD.usr.dist
+++ b/etc/mtree/BSD.usr.dist
@@ -14,6 +14,8 @@
     lib
         debug
         ..
+        engines
+        ..
         gcc47
             plugin
                 include
@@ -56,6 +58,8 @@
         ..
         i18n
         ..
+        ossl-modules
+        ..
         priv
             profile
             ..
diff --git a/games/factor/Makefile b/games/factor/Makefile
index d87d2003ab..91d8012a1a 100644
--- a/games/factor/Makefile
+++ b/games/factor/Makefile
@@ -8,7 +8,7 @@ MLINKS+=factor.6 primes.6
 GAMESCRYPTO=
 
 CFLAGS+=	-I${.CURDIR}/../primes
-CFLAGS+=	-DHAVE_OPENSSL
+CFLAGS+=	-DHAVE_OPENSSL -DOPENSSL_SUPPRESS_DEPRECATED
 
 .PATH:	${.CURDIR}/../primes
 
diff --git a/gnu/lib/libcryptsetup/Makefile b/gnu/lib/libcryptsetup/Makefile
index 7940faa1d8..4959972596 100644
--- a/gnu/lib/libcryptsetup/Makefile
+++ b/gnu/lib/libcryptsetup/Makefile
@@ -8,7 +8,7 @@ SRCS+=		backends.c libdevmapper.c setup.c utils.c \
 INCS+=		libcryptsetup.h
 
 CFLAGS+=	-I${CRYPTSETUP_DIR}/lib
-CFLAGS+=	-I${.CURDIR}/../../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../../crypto/openssl/include
 
 .PATH: ${CRYPTSETUP_DIR}/lib
 
diff --git a/gnu/lib/libluks/Makefile b/gnu/lib/libluks/Makefile
index 4dcac6b202..769285fcdb 100644
--- a/gnu/lib/libluks/Makefile
+++ b/gnu/lib/libluks/Makefile
@@ -7,7 +7,8 @@ SRCS+=		af.c hexprint.c keyencryption.c keymanage.c pbkdf.c random.c
 INCS+=		luks.h
 
 CFLAGS+=	-I${CRYPTSETUP_DIR}/luks
-CFLAGS+=	-I${.CURDIR}/../../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 .PATH: ${CRYPTSETUP_DIR}/luks
 
diff --git a/gnu/sbin/cryptsetup/Makefile b/gnu/sbin/cryptsetup/Makefile
index c90f35b0b4..d11c5747ea 100644
--- a/gnu/sbin/cryptsetup/Makefile
+++ b/gnu/sbin/cryptsetup/Makefile
@@ -1,7 +1,6 @@
 CRYPTSETUP_DIR=		${.CURDIR}/../../../contrib/cryptsetup
 
 PROG=		cryptsetup
-
 .PATH:		${CRYPTSETUP_DIR}/src
 CFLAGS+=	-I${CRYPTSETUP_DIR}/src
 SRCS=		cryptsetup.c
@@ -24,9 +23,10 @@ CFLAGS+=	-I. -I${CRYPTSETUP_DIR} -D_BSD_SOURCE
 DPADD+=		${LIBDM} ${LIBPROP}
 LDADD+=		-ldm -lprop
 
-DPADD+=		${LIBCRYPTO}
-LDADD+=		-lprivate_crypto
+DPADD+=		${LIBCRYPTO} ${LIBPTHREAD}
+LDADD+=		-lprivate_crypto -lpthread
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../../crypto/openssl/include
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 .include <bsd.prog.mk>
diff --git a/initrd/mkinitrd.sh b/initrd/mkinitrd.sh
index c33b86000d..954a9876fd 100755
--- a/initrd/mkinitrd.sh
+++ b/initrd/mkinitrd.sh
@@ -63,7 +63,7 @@ RESCUE_DIR="/rescue"
 BOOT_DIR="/boot"
 
 # Maximum size (number of MB) allowed for the initrd image
-INITRD_SIZE_MAX="15"  # MB
+INITRD_SIZE_MAX="19"  # MB
 
 # When run from the buildworld/installworld environment do not require that
 # things like uniq, kldload, mount, newfs, etc be in the cross-tools.
diff --git a/lib/Makefile b/lib/Makefile
index 4e24ed1cc1..8ba2d27044 100644
--- a/lib/Makefile
+++ b/lib/Makefile
@@ -23,8 +23,8 @@
 # Otherwise, the SUBDIR list should be in alphabetical order.
 
 SUBDIR_ORDERED= \
-	librecrypto \
-	libressl \
+	libcrypto \
+	libssl \
 	libcrypt \
 	libbz2 \
 	libzstd \
diff --git a/lib/libarchive/Makefile b/lib/libarchive/Makefile
index 038439c1ca..cfca77b56f 100644
--- a/lib/libarchive/Makefile
+++ b/lib/libarchive/Makefile
@@ -9,6 +9,7 @@ SHLIB_MAJOR=	5
 CFLAGS+=	-DHAVE_CONFIG_H
 CFLAGS+=	-I${.OBJDIR} -I${.CURDIR} -I${CONTRIBDIR}
 CFLAGS+=	-I${.CURDIR}/../../contrib/zstd/lib
+CFLAGS+=	-DOPENSSL_SUPPRESS_DEPRECATED
 
 # This can be changed back to CFLAGS once iconv works correctly with
 # statically linked libraries (iconv uses dynamic-only dlopen(3))
@@ -18,7 +19,7 @@ WARNS?=	2
 DPADD=	${LIBBZ2} ${LIBLZMA} ${LIBCRYPTO} ${LIBZ} ${LIBZSTD}
 LDADD=	-lbz2 -llzma -lprivate_crypto -lz -lprivate_zstd
 LDFLAGS+=	${PRIVATELIB_LDFLAGS}
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 
 INCS=	archive.h archive_entry.h
 
diff --git a/lib/libcrypt/Makefile b/lib/libcrypt/Makefile
index 59f5df71b9..5676fbc045 100644
--- a/lib/libcrypt/Makefile
+++ b/lib/libcrypt/Makefile
@@ -17,7 +17,7 @@ MAN=		crypt.3
 MLINKS=		crypt.3 crypt_get_format.3 crypt.3 crypt_set_format.3
 MLINKS+=	crypt.3 encrypt.3 crypt.3 setkey.3
 CFLAGS+=	-I${.CURDIR}/../omd -I${.CURDIR}/../libutil
-CFLAGS+=	-I${.CURDIR}/../../crypto/libressl/include
+CFLAGS+=	-I${.CURDIR}/../../crypto/openssl/include
 CFLAGS+=	-I${.CURDIR} -DHAS_DES -DHAS_BLOWFISH
 # And the auth_getval() code and support.
 .PATH:		${.CURDIR}/../libutil
